package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("RouteOverride")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class RouteOverride implements Marshallable {
	private Url account;
	private String partition;

    //
	public Url getAccount() {
	    return account;
	}
	public void setAccount(final Url value) {
	    this.account = value;
	}

	public RouteOverride account(final Url value) {
	    setAccount(value);
	    return this;
	}
	public RouteOverride account(final String value) {
	    setAccount(Url.toAccURL(value));
	    return this;
	}
	public String getPartition() {
	    return partition;
	}
	public void setPartition(final String value) {
	    this.partition = value;
	}

	public RouteOverride partition(final String value) {
	    setPartition(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.account == null)) {
            marshaller.writeUrl(1, this.account);
        }
        if (!(this.partition == null || this.partition.length() == 0)) {
            marshaller.writeString(2, this.partition);
        }
        return marshaller.array();
    }
}
